/***********************************************************************************************************************
 *
 * blueMarine Metadata - open source media workflow
 * Copyright (C) 2007-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~metadata-src
 *
 **********************************************************************************************************************/
package it.tidalwave.metadata.impl;

import java.util.Map;
import java.util.WeakHashMap;
import org.openide.loaders.DataObject;
import it.tidalwave.metadata.Metadata;
import it.tidalwave.metadata.MetadataFactory;
import javax.annotation.Nonnull;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class MetadataFactoryImpl implements MetadataFactory
  {
    private final Map<DataObject, MetadataImpl> metadataMapByDataObject = new WeakHashMap<DataObject, MetadataImpl>();
            
    /***************************************************************************
     *
     * {@inheritDoc}
     *
     **************************************************************************/
    @Nonnull 
    public Metadata findOrCreateMetadata (@Nonnull final DataObject dataObject) 
      {
        MetadataImpl metadata = metadataMapByDataObject.get(dataObject);
        
        if (metadata == null)
          {
            metadata = new MetadataImpl(dataObject);
            metadataMapByDataObject.put(dataObject, metadata);
          }
          
        return metadata;
      }
  }  
